// LineReaderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LineReader.h"
#include "LineReaderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLineReaderDlg dialog

CLineReaderDlg::CLineReaderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLineReaderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLineReaderDlg)
	m_port = 0;
	m_Line = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLineReaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLineReaderDlg)
	DDX_Text(pDX, IDC_EDIT1, m_port);
	DDX_Text(pDX, IDC_EDIT2, m_Line);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLineReaderDlg, CDialog)
	//{{AFX_MSG_MAP(CLineReaderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpne)
	ON_BN_CLICKED(IDC_BUTTON2, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLineReaderDlg message handlers

BOOL CLineReaderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  m_hFile = NULL;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLineReaderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLineReaderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLineReaderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLineReaderDlg::OnOpne() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);

  if(this->m_hFile != NULL)
      CloseHandle(m_hFile);
  
  char COM_string[32];
  DCB dcb;	

	sprintf(COM_string,"\\\\.\\COM%d", this->m_port);
	m_hFile = CreateFile(COM_string, GENERIC_READ|GENERIC_WRITE, 0, NULL,						
	    OPEN_EXISTING, 0,NULL);

	if(m_hFile != INVALID_HANDLE_VALUE)
	{		
    GetCommState(m_hFile, &dcb);

		dcb.BaudRate  = CBR_9600;  // FORMALLY, CONNECT BAUD DOESN`T MATTER (Virtual Com Port)
		dcb.ByteSize  = 8;             
		dcb.Parity    = NOPARITY;        
		dcb.StopBits  = ONESTOPBIT;    

		COMMTIMEOUTS CommTimeOuts;
		CommTimeOuts.ReadIntervalTimeout          = MAXDWORD;
		CommTimeOuts.ReadTotalTimeoutMultiplier   = 0;
		CommTimeOuts.ReadTotalTimeoutConstant     = 0;
		CommTimeOuts.WriteTotalTimeoutMultiplier  = 0;
		CommTimeOuts.WriteTotalTimeoutConstant    = 1000;
		SetCommTimeouts(m_hFile, &CommTimeOuts);
		SetCommState(m_hFile, &dcb);
	}
	else 
	{
		MessageBox("Can`t Open Port", "Error", MB_ICONERROR);	
		return;
	}
	
  MessageBox("Open OK", "Info", MB_ICONINFORMATION);
	
}

void CLineReaderDlg::OnRead() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  
  if(this->m_hFile == NULL)
  {
    MessageBox("You should open\nport first", "Info", MB_ICONINFORMATION);
    return;
  }

 
  if(this->m_Line <= 0 || this->m_Line > 24)
  {
    MessageBox("Please, select\ncorrect line number", "Info", MB_ICONINFORMATION);
    return;
  }  


  DWORD lpdwBytesWritten;
  char buf[32];

  int len = sprintf(buf, "$KE,RD,%d\r\n", this->m_Line); 

  WriteFile(m_hFile, buf, len, &lpdwBytesWritten, NULL);  


  // Make littele pause for wait module anser
  Sleep(20); // Wait 20 ms

  // Clear port buffer from previous data  
  //PurgeComm(m_hFile, PURGE_TXCLEAR );
  
	DWORD dwBytesRead;
	unsigned char pBuff[128];

	ReadFile(m_hFile, &pBuff, sizeof(pBuff), &dwBytesRead, NULL);

  
	if(dwBytesRead > 0)
	{
    // We must get anser like this: #RD,<LineNumber>,<Value>

    char waitBuf[32];
    int wLen = sprintf(waitBuf, "#RD,%02d,", this->m_Line);

    if( memcmp(pBuff, waitBuf, wLen) == 0)  // identical
    {
      int value = atoi((char*)(&pBuff[wLen]));
      if(value < 0 || value > 1)
      {
        MessageBox("Read Line fail1", "Info", MB_ICONERROR);
        return;
      }

      CString s1;
      s1.Format("Read Line:\nLine: %d\nValue: %d", this->m_Line, value);
      MessageBox(s1, "Info", MB_ICONINFORMATION);
    }
    else
    {

      if(memcmp(pBuff, "#RD,WRONGLINE", 13) == 0)
      {
        MessageBox("This line setup as OUTPUT\nCan`t read data.", "Info", MB_ICONINFORMATION);
        return;
      }

      MessageBox("Read Line fail2", "Info", MB_ICONERROR);
    }
  }
  else
  {
    MessageBox("Read Line fail3", "Info", MB_ICONERROR);
  }
	
}
